﻿using ProjectAirBomber.Drawnings;

public class DrawingBomberCompareByType : IComparer<DrawningBomber?>
{
    public int Compare(DrawningBomber? x, DrawningBomber? y)
    {
        if (x == null && y == null) return 0;
        if (x == null || x.EntityBomber == null)
        {
            return 1;
        }

        if (y == null || y.EntityBomber == null)
        {
            return -1;
        }

        if (x.GetType().Name != y.GetType().Name)
        {
            return x.GetType().Name.CompareTo(y.GetType().Name);
        }

        var speedCompare = x.EntityBomber.Speed.CompareTo(y.EntityBomber.Speed);
        if (speedCompare != 0)
        {
            return speedCompare;
        }

        return x.EntityBomber.Weight.CompareTo(y.EntityBomber.Weight);
    }
}